﻿using System;
using InternshipSystem.Api.Security;
using Microsoft.AspNetCore.Mvc.ModelBinding;
using Microsoft.AspNetCore.Mvc.ModelBinding.Binders;

namespace InternshipSystem.Api.ModelBinders
{
    public class UserBinderProvider : IModelBinderProvider
    {
        public IModelBinder GetBinder(ModelBinderProviderContext context)
        {
            if (context == null)
            {
                throw new ArgumentNullException(nameof(context));
            }

            if (context.Metadata.ModelType == typeof(User))
            {
                return new BinderTypeModelBinder(typeof(UserBinder));
            }

            return null;
        }
    }
}