﻿using FluentValidation;

namespace InternshipSystem.Api.Queries
{
    public class CompanyForm
    {
        public long? Id { get; set; }
        public string Nip { get; set; }
        public string Name { get; set; }
        
        public class Validator : AbstractValidator<CompanyForm>
        {
            public Validator()
            {
                RuleFor(c => c.Id).NotNull()
                    .When(c => !string.IsNullOrEmpty(c.Nip) || !string.IsNullOrEmpty(c.Name));
                RuleFor(c => c.Nip).NotEmpty()
                    .When(c => !c.Id.HasValue);
                RuleFor(c => c.Name).NotEmpty()
                    .When(c => !c.Id.HasValue);
            }
        }
    }
}